<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

			<title>How Can Stylometry Identify New Genres? Metadata for the Evaluation of Stylometric Clusterings</title>

			<meta name="description" content="Regular Expressions (Search)">
		<meta name="author" content="José Calvo Tello">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<link rel="stylesheet" href="../../lib/reveal/dist/reset.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/reveal.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/theme/white.css" id="theme">
		<link rel="stylesheet" href="custom.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="../../lib/reveal/plugin/highlight/monokai.css" id="highlight-theme">
	</head>

	<body>

        <div class="reveal">
            <div class="slides">
              
				<section data-markdown="" data-separator="^\n---\n" data-separator-vertical="^\n--\n" data-charset="utf-8">
					<script type="text/template">
<!-- .slide: class="firstSlide" -->			
### How Can Stylometry Identify New Genres?
#### Metadata for the Evaluation of Stylometric Clusterings

<hr />

##### Dr. José Calvo Tello
###### Göttingen State and University Library (SUB)

<hr />

###### DH Lunch Kraków, 04.03.2022

<!--https://jose.calvotello.pages.gwdg.de/slides/talks/20201117_DH_Romanistik/-->

<img data-src="./img/identification of genres in literature by mashine learning_drawer vqgan_replicate-prediction-ibghwq2ahbfwhdl52ohl525cuq.png" width="300"/>


<br />
<img data-src="./../../images/GAU_SUB_horizontal_cmyk.jpg" width="500"/>



---

# Hidden Genres?
- Is it possible that we have been ignoring groups of texts that are similar?
- What if we have been ignoring subgenres?
- If so, how can those be identified?
- And how can they be evaluated?


--

<img data-src="./img/butterfly_genre.jpg" width="500"/>



--

<img data-src="./img/stylometry_category_literature.jpg" width="500"/>


--

<img data-src="./img/clustering_stylometry_classification.jpg" width="500"/>


--

### Thanks to Jan and Maciej for stylo, their workshops and their work

<img data-src="./img/2014_ESU.png" width="500"/>

<br />

* ESU 2014


--

## 6 years later...

<img data-src="./../../images/jose_calvo_con_su_bebe.jpg" width="500"/>


--

## PhD Viva!

<img height="500" data-src="img/viva.jpg" />

--

### The Novel in the Spanish Silver Age: A Digital Analysis of Genre through Machine Learning

* 6.2. Identification of Hidden Subgenres
* https://www.transcript-verlag.de/978-3-8376-5925-2

<br />
<img data-src="./../../images/thesis.jpg" width="300"/>

---

# Corpus of Novels of the Spanish Silver Age

--

## Corpus 

* Corpus of Novels of the Spanish Silver Age: CoNSSA
* Designed based on literary manuals
* Around 350 Spanish novels (1880-1939)
* 22 million tokens
* TEI XML
* https://github.com/cligs/conssa
* https://github.com/cligs/scripts-ne

--

## Linguistic Annotation

* TEI-tags
* Narrative characteristics of the sentences
* Grammatical annotation (Freeling)
* Semantic features (WordNet and catalogs from the dictionary *María Moliner*)
* Entities

--

<img data-src="img/texts.png" />


--
## 25 Fields of Literary Metadata

- Narrator
- Protagonist (gender, age, social level, profession)
- Setting (period, span of action, continent, country, place, existing place)
- Others: Representation, type of end, text-author relation

<img width="500" data-src="img/literary-metadata.png">

--
## How is the Ending of the Novel during the Period?

<img data-src="img/CoNSSA_barstacked_decade_end_ordinal.png" />

--

<img width="700" data-src="img/setting-place.png">

- https://geobrowser.de.dariah.eu/?csv1=https://cdstar.de.dariah.eu/dariah/EAEA0-A43B-E9CE-84C6-0

--

## Genre Labels from Several Sources

<img width="500" data-src="img/genre-labels.png">

--

## Three Levels of Information for each Novel

- Genre labels
- Literary features (metadata)
- Linguistic features (annotation)

--

## Combination of these three Types of Information!
- Use linguistic features to predict literary features
- Use literary features to predict genre labels
- Compare classification results using linguistic and literary features
- ...

--

### What is a Genre? A Graph Unified Model of Categories, Texts, and Features

https://www.youtube.com/watch?v=xzJDbcEBV1U

<img data-src="img/youtube-video.png" width="600"/>

---

# Identification of Subgenres

--

## Why Hidden Subgenres?

- Authors tend to made-up their own subgenre-labels
- Researchers tend to study one single author
- **Hypothesis**: Researcher have been overlooking patterns across authors that can be understood as hidden subgenres

--

## References

- Santini, M. (2011). *Automatic Identification of Genre in Web Pages: A New Perspective*. Saarbrücken: LAP Lambert Academic Publishing.
    - Zero-to-multi genre scheme

--

# Which Method?

* <del>Classification</del>
* **Clustering**

--


<img width="600" data-src="img/boromit_clustering_genre.jpg">


--


<img width="700" data-src="img/figure_076.png">

--

<img width="600" data-src="img/figure_075.png">



--

## Three Problems

--

### 1. Clustering
<img width="600" data-src="img/gru_algortihm_cluster.jpg">


<!--### 1. When literary texts are clustered, the groups tend to show authorship: **authorial signal**. How to avoid that?-->

--

### 2. Number of Clusters?
<img width="700" data-src="img/figure_076.png">




--

### 2. Number of Clusters?
<img width="300" data-src="img/escobar_number_clusterings.jpg">

--

## Measuring the Authorial Signal (Adjusted Rand Index)

<img width="700" data-src="img/figure_077.png">


--

## Assumption of Scholastic Model
* A text belongs to one subgenre
<img width="700" data-src="img/figure_005.png">

--

### <del>Scholastic Model</del>

### Zero-to-Multi Genre Scheme of Genre (Santini)

* Any text can participate in ANY number of genres
* From zero
* To multiple labels

--

## What does this Theoretical Change Means for the Machine Learning?

* **Classification**: <del>Multi-class task</del> Multi-label task
* **Clustering**: <del>n clusters</del> **Two clusters** (binary clusters)

--

<img width="700" data-src="img/figure_076.png">



--

<img width="700" data-src="img/realizing_number_clusters.jpg">

--

## What if the Cluster can only Divide the Novels in Binary Groups?

<img width="700" data-src="img/figure_079.png">

--


<img width="500" data-src="img/kid_clustering.jpg">

--

## Clusters with Several Parameters

- Features: combination of features
- Transformations: tf-idf, log, log10-zscores, tfidf-zscores
- Algorithms: k-means, Ward, spectral clustering
- MFF: 10, 50, 100, 500, 1000, 2000, 3000, 5000
- 10 times
- Result: **914 competing clusters**

--

<img width="500" data-src="img/clustering_catalonian.jpg">


--
## 3. How to evaluate a new hypothetical genre?

“One can always find a property common to two texts, and therefore put them together in one class” (Todorov 1976, 162)

--

<img width="300" data-src="img/thor_hulk_cluster_subgenre.jpg">


--

## Criteria

1. **Recurring**: Repeatedly in several attempts with different parameters.
2. **Not explainable by other categories**: Not already known subgenres, authorship, or periodization
3. **Explainable by complex features**: Show statistical differences in the **metadata** 

--

# Cluster of the Clusters

<img width="600" data-src="img/figure_083.png">

- Which of these appeared several times with different parameters?
- Which of these clusters cannot be explained by other metadata?

--

## Two Best Candidates for New Subgenres

- Cluster 50
- Cluster 217

--

## Cluster 50
- 11 novels this category (from 353)
- Explainable by other categories?
  - dialogue novel (0.57 ARI)
  - poetic novel (0.23 ARI)
- Mono-dialogue novel

--

## Cluster 217

- 88 novels (from 353)

--

## Cluster 217: Explainable by other categories?

- modernist novel (0.20 ARI)
- author Miró (0.20)
- Valle-Inclán (0.10)
- Azorín (0.09)
- the biographic subgenre (0.08)
- decade of 1900 (0.06)
- the philosophical and poetic novel (0.06)

--

## Three Levels of Information

- Linguistic features 
- Genre labels
- **Literary features (metadata)**

--

## Statistical Tests with Literary Metadata


<img width="600" data-src="img/cluster_evaluation_statistical_tests_literary_metadataindex.jpg">


--

## **Explainable by complex features**: Show statistical differences in the **metadata** 

- Statistical tests to observe which are the particularities of these clusters
- Chi Square test for categorical values
- Mann-Whitney U for numerical values


--
## Cluster 217

- 26 metadata fields, dissimilarities in 19 (p-value &lt; 0.05, 6 fields p-value &lt; 0.001). 
- **Metadata**: more autobiographic, neutral representation of the world, autodiegetic narrator, male older protagonist (typically an artist). Setting is more likely to be in rural areas of Spain, often as a trip.

--

## Empirical Description of Cluster 217

- **Textual features**: shorter novels, with less direct speech
- **Linguistic features**: more punctuation, fewer verbs
- **Semantic features**: more frequent objects, plants, weather, body, substances, animals, perception
- **Authorial features**: Miró-Valle-Azorín vs. Baroja-Galdós-Bazán


--


<img width="600" data-src="img/cat_hypothesis_works6708b1.jpg">

--

## Hypothetical New Subgenre!

- Cluster 217
- **Proposal**:  ***bucolic novel***

---

# Conclusions

--

## A Hypothetical New Subgenre

- Found with linguistic features
- Evaluated and explained with literary metadata
- Cluster 217: ***bucolic novel***

--

## Identification of Subgenre
- <del>Scholastic model of genre</del>
- The zero-to-multi genre scheme
- Binary clusters
- Ignore authorial signal
- A theoretical change solved two technical problems

--

<img width="400" data-src="img/sensible_metadata.jpg">

--

<img width="400" data-src="img/swords_corpora_libraries_lod.jpg">

--

## Dziękujemy za uwagę

--

# Discussion!

<img width="400" data-src="img/me_explaning_cluster_scholars.jpg">


---

# Further Slides

--

<img width="700" data-src="img/CoNSSA-canon_indepdendet_boxplotstype-end_ordi-protagonist-age_ordi-protagonist-social-level_ordi-setting_ordi.png">



--

## Evaluation of Parameters with other Subgenre Labels

- **Features**: tokens, lemmata, semantic annotation, linguistic annotation, mixed model 
- **Transformations**: relative, tf-idf, log, binary, zscores, log10-zscores, tfidf-zscores
- **Algorithms**: k-means, agglomerative clustering Ward, spectral clustering (**more?**)
- **Number of most frequent features**: 10, 50, 100, 500, 1000, 2000, 3000, 5000, 7000.
- 10 times


--



## Meta-Cluster 0, Cluster 50

- 11 novels (from 353)
- Out of 213 fields, **66 show significant difference (p &lt; 0.05)**
- **Textual features**: shorter novels (37,600 vs. 64,327 tokens), oral novels without direct speech: letters, dialogue
- **Metadata**: autodiegetic narrator
- **Linguistic features**: more pronouns, fewer articles, prepositions, numbers, adjectives
- **Semantic features**: more cognition and emotion, fewer animals, objects, body parts, locations...
- **Authorial features**: Authors tend to write also theatre
- Cluster 50: ***mono-dialogue novel***


--

<img width="600" data-src="img/figure_082.png">


--


## Which are the Best Clusters to represent each Meta-Cluster?

- Calculation of ARI of each pair of cluster within meta-cluster
- Highest Median ARI

<img width="600" data-src="img/figure_083.png">

--

## Best Clusters (Highest Median ARI)

- Meta-Cluster 0, Cluster 50
- Meta-Cluster 1, Cluster 217



--

## Classification of both Clusters Comparing with other Subgenres


<img width="700" data-src="img/figure_084.png">


--

## Meta-Cluster 0, Cluster 50

- 11 novels (from 353)
- Out of 213 fields, **66 show significant difference (p &lt; 0.05)**
- **Textual features**: shorter novels (37,600 vs. 64,327 tokens), oral novels without direct speech: letters, dialogue
- **Metadata**: autodiegetic narrator
- **Linguistic features**: more pronouns, fewer articles, prepositions, numbers, adjectives
- **Semantic features**: more cognition and emotion, less animals, objects, body parts, locations...
- **Authorial features**: Authors tend to write also theatre
- Cluster 50: **mono-dialogic subgenre?**



--

				
					</script>
				</section>
            </div>
        </div>

        <script src="../../lib/reveal/dist/reveal.js"></script>
        <script src="../../lib/reveal/plugin/zoom/zoom.js"></script>
        <script src="../../lib/reveal/plugin/notes/notes.js"></script>
        <script src="../../lib/reveal/plugin/search/search.js"></script>
        <script src="../../lib/reveal/plugin/markdown/markdown.js"></script>
        <script src="../../lib/reveal/plugin/highlight/highlight.js"></script>
        <script>
    
          // Also available as an ES module, see:
          // https://revealjs.com/initialization/
          Reveal.initialize({
            controls: true,
            progress: true,
            center: true,
            hash: true,
    
            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
          });
    
        </script>
    
      </body>
    </html>
    